<?php

namespace FiloBlu\CategoryPagination\Plugin\Model\ResourceModel\Product;

class Collection {

    protected $registry;
    protected $helper;
    protected $_toolbar;

    public function __construct(
    \Magento\Framework\Registry $registry, \FiloBlu\CategoryPagination\Helper\Data $helper, \Magento\Catalog\Block\Product\ProductList\Toolbar $_toolbar) {
        $this->registry = $registry;
        $this->helper = $helper;
        $this->_toolbar = $_toolbar;
    }

    public function afterGetLastPageNumber(\Magento\Catalog\Model\ResourceModel\Product\Collection $collection) {
        $collectionSize = (int) $collection->getSize();

        if (0 === $collectionSize) {
            return 1;
        }

        $listMode = $this->_toolbar->getCurrentMode();
        if ($this->registry->registry("current_category")) {
            $_categoryId = $this->registry->registry("current_category")->getId();
        }
        $productNumberPage1 = $this->helper->getProductNumber($listMode, 1, $_categoryId);
        $productNumberPageOther = $this->helper->getProductNumber($listMode, 2, $_categoryId);
        
        $sizeFromSecondPage = $collectionSize - $productNumberPage1;
        
        if ($sizeFromSecondPage > 0) {
            return ceil($sizeFromSecondPage / $productNumberPageOther) + 1;
        }
        else {
            return 1;
        }
    }
}
